"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _forEach2 = require("lodash/forEach");

var _forEach3 = _interopRequireDefault(_forEach2);

exports.compileModules = compileModules;

var _luamin = require("luamin");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function compileModules(modulesData, entryModuleName) {
    // console.log(modulesData);

    var code = "\n        local __lc_modules = {};\n        local function __lc_add_module(name, module)\n            __lc_modules[name] = {\n                loaded = false,\n                module = module\n            }\n        end\n        local function __lc_module(moduleName)\n            local moduleContainer = __lc_modules[moduleName]\n\n            if not moduleContainer then\n                return\n            end\n\n            if not moduleContainer.loaded then\n                moduleContainer.module = moduleContainer.module(__lc_module)\n                moduleContainer.loaded = true\n            end\n\n            return moduleContainer.module\n        end\n\n    ";

    (0, _forEach3.default)(modulesData, function (moduleInfo, moduleName) {
        var moduleCode = "\n            __lc_add_module(\"" + moduleName + "\", function()\n                " + (0, _luamin.minify)(moduleInfo.ast) + "\n            end)\n        ";

        code += moduleCode;
    });

    code += "return __lc_module(\"a\")";
    code = (0, _luamin.minify)(code);

    return code;
}
//# sourceMappingURL=compileModules.js.map